require 'ScanDroid_lib.rb'
def run  
  t=ScanDroid.new
  case ARGV[0]
    when "-apk"
      @filename=ARGV[1]
    else
      system('cls')
      puts "Error in correct syntax!\nTry: ScanDroid.rb -apk [Filename.apk] -rule [rule_file]"
      Process.exit
  end
  case ARGV[2]
    when "-rule"
      @rule=ARGV[3]
    else
      system('cls')
      puts "Error in correct syntax!\nTry: ScanDroid.rb -apk [Filename.apk] -rule [rule_file]"
      Process.exit
  end
  if !@filename
    puts "Enter Filename(including extension): "
    @filename=gets.chomp
  end
  if !@rule
    puts "Enter Rules File(including extension): "
    @rule=gets.chomp
  end
  if !File.exists?(@filename)
    puts "\nCannot find #{@filename}! Please make sure the path of the file is correct."
    Process.exit
  end
  if !File.exists?(@rule)
    puts "\nCannot find #{@rule}! Please make sure the path of the file is correct."
    Process.exit
  end  
  puts "Working on "+@filename+" ... "
  t.extract(@filename)
  system('cls')
  t.xml(@filename)
  system('cls')
  t.dex2clas(@filename)
  system('cls')
  t.clas2jav(@filename)
  system('cls')
  t.manifest(@filename)
  system('cls')
  t.check(@filename,@rule)
  puts ("\nPermissions Stored at /#{@filename[0,3]}/permissions.txt\n")
end
system('@echo off')
system('prompt.')
run()
system('prompt')